## mlpack 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -264,15 +264,6 @@
   endif (${MLPACK_TMP_REV_INFO_RESULT} EQUAL 0)
 endif (GIT_FOUND)
 
-# Recurse into the rest of the project.
-add_subdirectory(src/mlpack)
-
-# If we need to keep gitversion.hpp up to date, then make sure the mlpack target
-# depends on it.
-if (USING_GIT STREQUAL "YES")
-  add_dependencies(mlpack mlpack_gitversion)
-endif (USING_GIT STREQUAL "YES")
-
 # Create a target to generate arma_config.hpp, which is used to warn the user
 # when they are doing something stupid when linking something against mlpack.
 include(CMake/CreateArmaConfigInfo.cmake)
@@ -286,3 +277,13 @@
     COMMENT "Updating arma_config.hpp (if necessary)")
 set(MLPACK_SRCS ${MLPACK_SRCS}
     "${CMAKE_CURRENT_SOURCE_DIR}/src/mlpack/core/util/arma_config.hpp")
+
+# Recurse into the rest of the project.
+add_subdirectory(src/mlpack)
+
+# If we need to keep gitversion.hpp up to date, then make sure the mlpack target
+# depends on it.
+if (USING_GIT STREQUAL "YES")
+  add_dependencies(mlpack mlpack_gitversion)
+endif (USING_GIT STREQUAL "YES")
+
