=== debian/changelog ===
mlpack (2.0.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 15 Feb 2016 19:15:06 +0000
