=== debian/watch ===
version=3
http://www.mlpack.org/files/mlpack-(.*).tar.gz
