## mlpack 2.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,20 @@
 cmake_minimum_required(VERSION 2.8.5)
 project(mlpack C CXX)
 
-# Ensure that we have a C++11 compiler.
-include(CMake/CXX11.cmake)
-check_for_cxx11_compiler(HAS_CXX11)
-if(NOT HAS_CXX11)
-  message(FATAL_ERROR "No C++11 compiler available!")
-endif(NOT HAS_CXX11)
-enable_cxx11()
+# Ensure that we have a C++11 compiler.  In newer versions of CMake, this is
+# done with target_compile_features() when the mlpack library target is added in
+# src/mlpack/CMakeLists.txt.
+if (${CMAKE_MAJOR_VERSION} LESS 3 OR
+    (${CMAKE_MAJOR_VERSION} EQUAL 3 AND ${CMAKE_MINOR_VERSION} LESS 1))
+  # Older versions of CMake do not support target_compile_features(), so we have
+  # to use something kind of hacky.
+  include(CMake/CXX11.cmake)
+  check_for_cxx11_compiler(HAS_CXX11)
+  if(NOT HAS_CXX11)
+    message(FATAL_ERROR "No C++11 compiler available!")
+  endif()
+  enable_cxx11()
+endif()
 
 # First, define all the compilation options.
 # We default to debugging mode for developers.
@@ -16,6 +23,12 @@
 option(ARMA_EXTRA_DEBUG "Compile with extra Armadillo debugging symbols." OFF)
 option(MATLAB_BINDINGS "Compile MATLAB bindings if MATLAB is found." OFF)
 option(TEST_VERBOSE "Run test cases with verbose output." OFF)
+option(BUILD_TESTS "Build tests." ON)
+option(BUILD_CLI_EXECUTABLES "Build command-line executables" ON)
+option(BUILD_SHARED_LIBS
+    "Compile shared libraries (if OFF, static libraries are compiled)" ON)
+
+enable_testing()
 
 # Include modules in the CMake directory.
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")
@@ -29,17 +42,17 @@
 if(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -ftemplate-depth=1000")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")
-endif(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+endif()
 
 # If using clang, we have to link against libc++ depending on the
 # OS (at least on some systems). Further, gcc sometimes optimizes calls to
 # math.h functions, making -lm unnecessary with gcc, but it may still be
 # necessary with clang.
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-  IF (APPLE)
+  if (APPLE)
     # detect OS X version. Use '/usr/bin/sw_vers -productVersion' to
     # extract V from '10.V.x'.)
-    EXEC_PROGRAM(/usr/bin/sw_vers ARGS
+    exec_program(/usr/bin/sw_vers ARGS
         -productVersion OUTPUT_VARIABLE MACOSX_VERSION_RAW)
     string(REGEX REPLACE
         "10\\.([0-9]+).*" "\\1"
@@ -53,52 +66,56 @@
       set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
       set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -stdlib=libc++")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
-     endif(${MACOSX_VERSION} LESS 9)
-  endif(APPLE)
+     endif()
+  endif()
 
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lm")
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lm")
   set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lm")
-endif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+endif()
 
 # Debugging CFLAGS.  Turn optimizations off; turn debugging symbols on.
 if(DEBUG)
   add_definitions(-DDEBUG)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -ftemplate-backtrace-limit=0")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -g -O0")
+  # mlpack uses it's own mlpack::backtrace class based on Binary File Descriptor
+  # <bfd.h> and linux Dynamic Loader <libdl.h> and more portable version in future
+  if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+    find_package(Bfd)
+    find_package(LibDL)
+    if(LIBBFD_FOUND AND LIBDL_FOUND)
+      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -rdynamic")
+      include_directories(${LIBBFD_INCLUDE_DIRS})
+      include_directories(${LIBDL_INCLUDE_DIRS})
+      add_definitions(-DHAS_BFD_DL)
+    else()
+      message(WARNING "No libBFD and/or libDL has been found!")
+    endif()
+  endif()
 else()
   add_definitions(-DARMA_NO_DEBUG)
   add_definitions(-DNDEBUG)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -O3")
-endif(DEBUG)
+endif()
 
 # Profiling CFLAGS.  Turn profiling information on.
 if(CMAKE_COMPILER_IS_GNUCC AND PROFILE)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
-endif(CMAKE_COMPILER_IS_GNUCC AND PROFILE)
-
-# mlpack uses backtrace() facilities. On some systems (e.g., GNU/Linux), it
-# resides in libc itself and requires <execinfo.h>; on other (e.g., OpenBSD)
-# it's provided by a separate library.
-find_package(Backtrace)
-if(Backtrace_FOUND)
-  include_directories(${Backtrace_INCLUDE_DIRS})
-  add_definitions(-DBACKTRACE_FOUND)
-  add_definitions(-DBACKTRACE_HEADER="${Backtrace_HEADER}")
-endif(Backtrace_FOUND)
+endif()
 
 # If the user asked for running test cases with verbose output, turn that on.
 if(TEST_VERBOSE)
   add_definitions(-DTEST_VERBOSE)
-endif(TEST_VERBOSE)
+endif()
 
 # If the user asked for extra Armadillo debugging output, turn that on.
 if(ARMA_EXTRA_DEBUG)
   add_definitions(-DARMA_EXTRA_DEBUG)
-endif(ARMA_EXTRA_DEBUG)
+endif()
 
 # Now, find the libraries we need to compile against.  Several variables can be
 # set to manually specify the directory in which each of these libraries
@@ -121,12 +138,12 @@
   set(ARMA_HAS_64BIT_WORD 0)
   if(NOT (${ARMADILLO_VERSION_MAJOR} LESS 5))
     set(ARMA_HAS_64BIT_WORD 1)
-  else(NOT (${ARMADILLO_VERSION_MAJOR} LESS 5))
+  else()
     # Can we open the configuration file?  If not, issue a warning.
     if(NOT EXISTS "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp")
       message(WARNING "Armadillo configuration file "
           "(${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp) does not exist!")
-    else(NOT EXISTS "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp")
+    else()
       # We are on a 64-bit system.  Does Armadillo have ARMA_64BIT_WORD enabled?
       file(READ "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp" ARMA_CONFIG)
       string(REGEX MATCH
@@ -135,8 +152,8 @@
           "${ARMA_CONFIG}")
 
       string(LENGTH "${ARMA_HAS_64BIT_WORD_PRE}" ARMA_HAS_64BIT_WORD)
-    endif(NOT EXISTS "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp")
-  endif(NOT (${ARMADILLO_VERSION_MAJOR} LESS 5))
+    endif()
+  endif()
 
   if(ARMA_HAS_64BIT_WORD EQUAL 0)
     message(WARNING "This is a 64-bit system, but Armadillo was compiled "
@@ -144,8 +161,15 @@
         "ARMA_64BIT_WORD to enable 64-bit indices (large matrix support). "
         "mlpack will still work without ARMA_64BIT_WORD defined, but will not "
         "scale to matrices with more than 4 billion elements.")
-  endif(ARMA_HAS_64BIT_WORD EQUAL 0)
-endif(CMAKE_SIZEOF_VOID_P EQUAL 8)
+  endif()
+else()
+  # If we are on a 32-bit system, we must manually specify the size of the word
+  # to be 32 bits, since otherwise Armadillo will produce a warning that it is
+  # disabling 64-bit support.
+  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
+    add_definitions(-DARMA_32BIT_WORD)
+  endif ()
+endif()
 
 # On Windows, Armadillo should be using LAPACK and BLAS but we still need to
 # link against it.  We don't want to use the FindLAPACK or FindBLAS modules
@@ -160,7 +184,7 @@
 
   if (NOT LAPACK_LIBRARY)
     message(FATAL_ERROR "Cannot find LAPACK library (.lib)!")
-  endif (NOT LAPACK_LIBRARY)
+  endif ()
 
   find_library(BLAS_LIBRARY
       NAMES blas libblas blas_win32_MT blas_win32
@@ -169,12 +193,12 @@
 
   if (NOT BLAS_LIBRARY)
     message(FATAL_ERROR "Cannot find BLAS library (.lib)!")
-  endif (NOT BLAS_LIBRARY)
+  endif ()
 
   # Piggyback LAPACK and BLAS linking into Armadillo link.
   set(ARMADILLO_LIBRARIES
        ${ARMADILLO_LIBRARIES} ${BLAS_LIBRARY} ${LAPACK_LIBRARY})
-endif (WIN32)
+endif ()
 
 # Include directories for the previous dependencies.
 include_directories(${ARMADILLO_INCLUDE_DIRS})
@@ -200,7 +224,7 @@
 if (MSVC)
   link_directories(${Boost_LIBRARY_DIRS})
   set(Boost_LIBRARIES "")
-endif (MSVC)
+endif ()
 
 # For Boost testing framework (will have no effect on non-testing executables).
 # This specifies to Boost that we are dynamically linking to the Boost test
@@ -213,7 +237,7 @@
 if (OPENMP_FOUND)
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
-endif (OPENMP_FOUND)
+endif ()
 
 # Create a 'distclean' target in case the user is using an in-source build for
 # some reason.
@@ -226,7 +250,7 @@
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
   set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
   set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
-else (WIN32)
+else ()
   # If not on Windows, put them under more standard UNIX-like places.  This is
   # necessary, otherwise they would all end up in
   # ${CMAKE_BINARY_DIR}/src/mlpack/methods/... or somewhere else random like
@@ -234,7 +258,7 @@
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib/)
   set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/)
   set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib/)
-endif (WIN32)
+endif ()
 
 # Determine whether or not this is a git repository, so that we can set the
 # version number if necessary.
@@ -251,7 +275,7 @@
       OUTPUT_STRIP_TRAILING_WHITESPACE)
   if (${MLPACK_TMP_REV_INFO_RESULT} EQUAL 0)
     set (USING_GIT "YES")
-    add_definitions(-D__MLPACK_GIT_VERSION)
+    add_definitions(-DMLPACK_GIT_VERSION)
     include(CMake/CreateGitVersionHeader.cmake)
 
     add_custom_target(mlpack_gitversion ALL
@@ -261,8 +285,8 @@
   # Add gitversion.hpp to the list of sources.
   set(MLPACK_SRCS ${MLPACK_SRCS}
       "${CMAKE_CURRENT_SOURCE_DIR}/src/mlpack/core/util/gitversion.hpp")
-  endif (${MLPACK_TMP_REV_INFO_RESULT} EQUAL 0)
-endif (GIT_FOUND)
+  endif ()
+endif ()
 
 # Create a target to generate arma_config.hpp, which is used to warn the user
 # when they are doing something stupid when linking something against mlpack.
@@ -273,17 +297,3 @@
         -D ARMADILLO_INCLUDE_DIR="${ARMADILLO_INCLUDE_DIR}"
         -D ARMADILLO_VERSION_MAJOR="${ARMADILLO_VERSION_MAJOR}"
         -P CMake/CreateArmaConfigInfo.cmake
-    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-    COMMENT "Updating arma_config.hpp (if necessary)")
-set(MLPACK_SRCS ${MLPACK_SRCS}
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/mlpack/core/util/arma_config.hpp")
-
-# Recurse into the rest of the project.
-add_subdirectory(src/mlpack)
-
-# If we need to keep gitversion.hpp up to date, then make sure the mlpack target
-# depends on it.
-if (USING_GIT STREQUAL "YES")
-  add_dependencies(mlpack mlpack_gitversion)
-endif (USING_GIT STREQUAL "YES")
-
