=== debian/control ===
--- 
+++ 
@@ -13,10 +13,10 @@
 		libarmadillo-dev,
 		txt2man,
 		doxygen, doxygen-latex, graphviz
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.mlpack.org/
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/mlpack.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/mlpack.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/mlpack.git
 
 Package: libmlpack-dev
 Section: libdevel
